=== debian/changelog ===
spectrum (20231022~git-1) UNRELEASED; urgency=medium

  * Initial release. (Closes: #nnnn)  <nnnn is the bug number of your ITP>

 -- pavroo <pavroo@onet.eu>  Sun, 22 Oct 2023 14:31:32 +0200
