=== debian/control ===
Source: spectrum
Section: sound
Priority: optional
Maintainer: pavroo <pavroo@onet.eu>
Build-Depends: build-essential, cmake, libasound2-dev, libavcodec-dev, libavfilter-dev, libavformat-dev, libfftw3-dev, libswresample-dev, libcurl4-openssl-dev, libxml++2.6-dev, git
Standards-Version: 3.9.6
Homepage: https://github.com/v1nns/spectrum

Package: spectrum
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ffmpeg, fftw2, libcurl4, libxml++2.6-2v5, cava
Description: Spectrum
 A simple and intuitive console-based music player written in C++
